console.log("Hello, Sky!");

/**** ☭☭☭☭☭☭☭☭☭☭☭☭ ******
/☭☭☭☭  Test skripta   ☭☭☭☭ *
******☭☭☭☭☭☭☭☭☭☭☭☭******/

// Ker kegel imamo?
var izbranKegel = 1;
if (window.location.hash.indexOf('kegel') > -1) {
  izbranKegel = window.location.hash.split('=')[1];
}

// Vidni kot
var FOV = 90;

// Parametri rotacije (euler)
var rotacijaX = 0.000;
var rotacijaY = 0.000;
var rotacijaZ = 0.000;

// Parametri pospeska
var accX = 0.000;
var accY = 0.000;
var accZ = 0.000;

// Scena, kamera in render
var scene = new THREE.Scene;
window.scene = scene;

/*
const axesHelper = new THREE.AxesHelper( 5 );
scene.add( axesHelper );
*/

var camera = new THREE.PerspectiveCamera(FOV, window.innerWidth / window.innerHeight, 0.1, 2000);
window.camera = camera;

var renderer = new THREE.WebGLRenderer({
    alpha: true
});
renderer.setSize(window.innerWidth, window.innerHeight);

// Belo ozadje
renderer.setClearColor(0xFFFFFF, 1);
// Črno ozadje
//renderer.setClearColor(0x000000, 1);

//var skupina = new THREE.Group();

// Dodaj test skatlo

// Sirina in visina test objekta
var width = 16;
var height = 128;

var radialnihSegmentov = 4;
var visinskihSegmentov = 128;
var geo = new THREE.BufferGeometry();
var offset = width;
var polozaji = [];

// visina: 128 segmentov
// sirina: 9 segmentov

var sirinaSegmentov = 9;
// Najprej "spodnja buba" 
var faktor = [
  2/sirinaSegmentov,  2/sirinaSegmentov
];

// Pol rocaj (1.4 do 2.8 segmenta, dolgo 62 segmentov)
var rocajSegmentov = 46;
for (var i = 0; i <= rocajSegmentov; i++) {
  faktor.push((1.4 + i / rocajSegmentov * 1.4) / sirinaSegmentov);
}

// pol stresica dol (2.8 do 7.4 segmenta)
var stresicaSegmentov = 48;
for (i = 0; i <= stresicaSegmentov; i++) {
  faktor.push((2.8 + i / stresicaSegmentov * 4.6) / sirinaSegmentov);
}

// Pa se zadnji naklon (7.4 do 3 segmente)
var konecSegmentov = 30;
for (i = 0; i <= konecSegmentov; i++) {
  faktor.push((7.4 - i / konecSegmentov * 4.4) / sirinaSegmentov);
}

console.log(faktor);

// spodnji krog
for (var s = 0; s < radialnihSegmentov; s++) {
  polozaji.push(
    0.0,
    0.0,
    0.0,
    Math.sin(2 * Math.PI * s / radialnihSegmentov) * width * faktor[0],
    Math.cos(2 * Math.PI * s / radialnihSegmentov) * width * faktor[0],
    0.0,
    Math.sin(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[0],
    Math.cos(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[0],
    0.0
  );
}
console.log(polozaji);
// vmesni segmenti
for (var h = 0; h < visinskihSegmentov; h++) {
  for (s = 0; s < radialnihSegmentov; s++) {
    polozaji.push(
      Math.sin(2 * Math.PI * s / radialnihSegmentov) * width * faktor[h],
      Math.cos(2 * Math.PI * s / radialnihSegmentov) * width * faktor[h],
      h * height / visinskihSegmentov,
      Math.sin(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[h],
      Math.cos(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[h],
      h * height / visinskihSegmentov,
      Math.sin(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[h],
      Math.cos(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[h],
      (h + 1) * height / visinskihSegmentov,
    );
  }
}

// zgornji krog
for (s = 0; s < radialnihSegmentov; s++) {
  polozaji.push(
    0,
    0,
    height,
    Math.sin(2 * Math.PI * s / radialnihSegmentov) * width * faktor[31],
    Math.cos(2 * Math.PI * s / radialnihSegmentov) * width * faktor[31],
    height,
    Math.sin(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[31],
    Math.cos(2 * Math.PI * (s + 1) / radialnihSegmentov) * width * faktor[31],
    height
  );
}

for (i = 0; i < polozaji.length; i++) {
  if (i % 3 == 2) {
    polozaji[i] -= height / 2;
  }
}


// Spremeni v vertexe
var vertices = new Float32Array(polozaji);
geo.setAttribute('position', new THREE.BufferAttribute(vertices, 3));

window.geo = geo;

/*
// Deformiramo za kegel
for (var n = 0; n < radialnihSegmentov; n += 1) {
  geo.attributes.position.array[1 + n * 3] += 10;
  geo.attributes.position.array[1 + n * 3 + 1] += 30;
  geo.attributes.position.needsUpdate = true
}
*/

var barva = new THREE.Color(0, 0, 0);
var barvaDodatni = new THREE.Color();
barvaDodatni.setHSL(0.6, 1.0, 0.5);
var mat = new THREE.MeshBasicMaterial({
  //color: 0xff00ff,
  color: barva,
  wireframe: true,
  transparent: true
});
window.mat = mat;
//var mat = new THREE.LineBasicMaterial({ color: 0xff00ff });
var kegel = new THREE.Mesh(geo, mat);
kegel.position.z += 64;
//kegel.position.y += 32;
kegel.position.y = -100;
kegel.rotation.z = 180;

if (izbranKegel == 0) {
  kegel.position.x = 40;
}

var barvaKrogleO = new THREE.Color();
barvaKrogleO.setHSL(Math.random(), 0.8, 0.5);
function novaKrogla () {
  var barvaKrogle = barvaKrogleO.clone();
  var mat = new THREE.MeshBasicMaterial({
    color: barvaKrogle,
    wireframe: true,
    transparent: true
  });
  var velikost = 1 + Math.random() * 5;
  var kroglaGeo = new THREE.SphereGeometry(velikost, 12, 12);
  var krogla = new THREE.Mesh(kroglaGeo, mat);

  krogla.position.x = (Math.random() - 1) * 200;
  krogla.position.y = (Math.random() - 1) * 10;
  krogla.position.z = (Math.random() - 1) * 300;

  krogla.position.y -= 100;
  krogla.position.x += 150;
  krogla.position.z += 230; // gor/dol


  //krogla.position.y += 200;

  scene.add(krogla);
  krogle.push(krogla);
}

//skupina.add(kegel);

// Za pospeskomer - os X
var gAX = new THREE.CylinderGeometry(10, 10, 10, 16);
var mAX = new THREE.MeshBasicMaterial({ color: 0xff000055 });
var AX = new THREE.Mesh(gAX, mAX);

//skupina.add(AX);

// Damo vse skupaj v kader
// scene.add(skupina);
scene.add(kegel);

// Quaternioni za rotacijo in kalibracijo
var qWW = new THREE.Quaternion();
var qPrej = new THREE.Quaternion();
var qObj = new THREE.Quaternion();
var qStart = new THREE.Quaternion();
var reset = false;
var calibrate = true;


var objekti = [kegel];
var dodatniObjekti = [];
var krogle = [];
var stevec = 0;

// Zacetna orientacija kegla
scene.rotation.x = 90;
scene.rotation.z = 270;

// Polozaj kamere
//camera.position.y = -64;
camera.position.z = 60;

//skupina.position.z = 32;
//skupina.position.y = -100;

function inputHandle () {
  if (kbdPressed.c) {
    calibrate = true;
    sendAll('/ww/calibrate');
  }
}


function render () {
  requestAnimationFrame(render);
  renderer.render(scene, camera);
  stevec += 1;

  objAnim();
  inputHandle();

  if (stevec % 10 == 0) {
    novaKrogla();
  }
};

// Funkcija za animacijo objektov
function objAnim() {
  // Rotacija kegla
  objekti.map(function (obj) {
    // Apliciramo rotacijo (po quaternionih - eulerji zajebavajo.)
    qObj = qWW.clone();
    qObj.multiply(qStart);
    obj.setRotationFromQuaternion(qObj);

    AX.scale.x = accX / 1000;
  });
  // Ce jih je prevec, pucaj
  while (dodatniObjekti.length > 100) {
    scene.remove(dodatniObjekti[0]);
    dodatniObjekti.shift();
  }
    
  dodatniObjekti.map(function (obj) {
    // Apliciramo rotacijo (po quaternionih - eulerji zajebavajo.)
    qObj = qWW.clone();
    //qObj.multiply(obj.qStart).multiply(qStart);
    //obj.setRotationFromQuaternion(qObj);

    obj.translateOnAxis(obj.premakniAxis, obj.premakniKolicina);

    // obj.material.color.offsetHSL(0, 0, 0.003);
    obj.material.opacity *= 0.98;
    obj.premakniKolicina *= 0.98;

    var dQ = obj.quaternion.multiply(obj.rotirajQ);
    /*
    dQ.multiply(obj.rotirajQ);
    obj.setRotationFromQuaternion(dQ);
    */

    /*
    obj.premakni.x *= 1.1;
    obj.premakni.y *= 1.1;
    obj.premakni.z *= 1.1;
    */
    obj.material.opacity *= 0.98;
  });

  barvaKrogleO.offsetHSL(-(2/1000), 0, 0);
  krogle.map(function (obj) {
    obj.material.opacity *= 0.98;
  });

  // Kalibracija rotacije kegla
  if (calibrate) {
    qStart = qWW.clone();
    qStart.conjugate();
    calibrate = false;
    console.log("RESET!");
  }


  // rotiramo skupino da se vidi
  //skupina.rotation.x += 0.003;
  //skupina.rotation.y += 0.005;
  //skupina.rotation.z += 0.007;

  if (kegel.scale.x > 1) {
    kegel.scale.x *= 0.95;
  }

  if (kegel.scale.z > 1) {
    kegel.scale.z *= 0.95;
  }


  // Dupliranje keglov
  //console.log(accX);
  kegel.material.color.offsetHSL(2 / 1000, 0, 0);
  if (accX > 1/* && (stevec % 10) == 0*/) {
    var dodatni = kegel.clone();
    dodatni.renderOrder = stevec;
    var dodatniMat = kegel.material.clone();
    var dodatniBarva = barvaDodatni.clone();
    dodatniMat.color = dodatniBarva;
    dodatni.material = dodatniMat;
    dodatni.premakniAxis = new THREE.Vector3(
      Math.random(),
      Math.random(),
      Math.random()
    );
    dodatni.premakniKolicina = (Math.random() - 1) * 10;
    var rQ = qWW.clone();
    rQ.invert();
    rQ.multiply(qPrej);
    dodatni.rotirajQ = rQ;

    //dodatni.qStart = kegel.quaternion.clone();
    dodatniObjekti.push(dodatni);
    scene.add(dodatni);
  }
};


// Inicializiraj
document.onreadystatechange = function () {
  if (document.readyState === 'complete') {
    document.getElementById("anim-container").appendChild(renderer.domElement);
    render();
  }
};

// Lep risajz
function onWindowResize() {
    camera.aspect = window.innerWidth / window.innerHeight;
    camera.updateProjectionMatrix();
    renderer.setSize(window.innerWidth, window.innerHeight);
}
window.addEventListener('resize', onWindowResize, false);


// Poslusaj OSC evente
var keysPressed = [0, 0, 0, 0];

const getVal = function (msg) {
  return msg.value;
}
var prepend = `/ww/0/ww/${izbranKegel}`;
console.log('prepend!', prepend);

var oscCallbacks = {};

oscCallbacks[`${prepend}'/keys`] = function(args) {
  keysPressed = args.map(getVal);
};
oscCallbacks[`${prepend}/quaternion`] = function (args) {
  // Popravimo osi (w x y z po defaultu HMM)
  [qPrej.w, qPrej.x, qPrej.y, qPrej.z] = [qWW.w, qWW.x, qWW.y, qWW.z];
  [qWW.w, qWW.x, qWW.y, qWW.z] =  args.map(getVal);
};
oscCallbacks[`${prepend}/accel`] = function (args) {
  [accX, accY, accZ] = args.map(getVal);
};
oscCallbacks[`${prepend}/gyro`] = function (args) {
  [rotacijaX, rotacijaY, rotacijaZ] = args.map(getVal);
};
oscCallbacks['/ww/calibrate'] = function () {
  calibrate = true;
};
oscCallbacks['/midi'] = function (args) {
  //console.log("MAMOMO MIDI!", args);
  var minus = (izbranKegel == 1) ? -1 : 1;
  // kegel.material.color.offsetHSL(minus * args[2].value / 1000, 0, 0);
  barvaDodatni.offsetHSL(minus * args[2].value / 1000, 0, 0);

    
  if (Math.random() < 0.5) {
    kegel.scale.x *= 1.5;
  } else {
    kegel.scale.z *= 1.5;
  }
    
  //kegel.scale.y *= 1 + (args[2] / 100000);
  //kegel.scale.z *= 1 + (args[2] / 100000);
};


const kbdPressed = {
  a: false,
  s: false,
  d: false,
  f: false,
  c: false
};

window.addEventListener('keydown', (e) => {
  kbdPressed[e.key] = true;
});

window.addEventListener('keyup', (e) => {
  if (e.key in kbdPressed) {
    kbdPressed[e.key] = false;
  }
});
